import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.*;
/**
 * Write a description of class Explosion here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Explosion  extends mouseListener
{
    GreenfootImage image = new GreenfootImage(30,30);

    int speed = 3;

    public Explosion()
    {
        image.scale(4, 4);
        image.setColor(Color.GRAY);
        image.fillOval(0, 0, 3, 3);
        image.setTransparency(100);
        setImage(image);
    }

    /**
     * Act - do whatever the Explosion wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        lookForBall();
        lookForBlock();
        adjustSize();
    }    

    private void lookForBlock()
    {
        List booms = getIntersectingObjects(Block.class);        
        Iterator i = booms.iterator();
        while(i.hasNext())
        {
            Block a = (Block) i.next();
            if(a instanceof Block)
            {
                if(getX() > a.getX())
                {
                    a.xs -= 2;
                }

                if(getX() < a.getX())
                {
                    a.xs += 2;
                }

                if(getY() < a.getY())
                {
                    a.ys += 2;
                }

                if(getY() > a.getY())
                {
                    a.ys -= 2;
                }
            }
        }
    }

    private void lookForBall()
    {
        List booms = getIntersectingObjects(Ball.class);        
        Iterator i = booms.iterator();
        while(i.hasNext())
        {
            Ball b = (Ball) i.next();
            if(b instanceof Ball)
            {
                if(getX() > b.getX())
                {
                    b.xs -= 2;
                }

                if(getX() < b.getX())
                {
                    b.xs += 2;
                }

                if(getY() < b.getY())
                {
                    b.ys += 2;
                }

                if(getY() > b.getY())
                {
                    b.ys -= 2;
                }
            }
        }
    }

    private void adjustSize()
    {
        if(image.getWidth() < 90 && speed > 0)
        {
            image.scale(image.getWidth()+speed, image.getHeight()+speed);
            image.clear();
            image.fillOval(0, 0, image.getWidth(), image.getHeight());
        }
        else if(image.getWidth() > -speed)
        {
            speed = -3;
            image.scale(image.getWidth()+speed, image.getHeight()+speed);
            image.clear();
            image.fillOval(0, 0, image.getWidth(), image.getHeight());
        }

        if(image.getWidth() <= -speed)
        {
            getWorld().removeObject(this);
            return;
        }
    }
}
